> For the complete documentation index, see [llms.txt](https://docs.pentaho.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pentaho.com/pba-report-designer/function-reference/script-functions.md).

# Script functions

The **Script** category contains functions that enable you to directly type in code from a supported scripting language.

* Bean-Scripting Framework (BSF)
* Bean-Scripting Host (BSH)
* JavaScript
* Single Value Query

The only unique object Pentaho offers in Report Designer for a scripting language is getValue for the Bean-Scripting Framework, which retrieves the current record or row, as shown below:

```
Object getValue()
  {
  	Object value = dataRow.get(&quot;RegionVariance&quot;);
      if (value instanceof Number == false)
      {
      	return Boolean.FALSE;
      }
      Number number = (Number) value;
      if (number.doubleValue() &lt; 0)
      {
      return Boolean.TRUE;
      }
      return Boolean.FALSE;
  }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pentaho.com/pba-report-designer/function-reference/script-functions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
